
/*
	PA6		SDA
	PA7		SCL
*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/sleep.h>
#include <inttypes.h>
//#include "suart.h"
#include "i2c.h"


/*
#define	SDA_HI		cbi(DDRA, 0)
#define	SDA_LO		sbi(DDRA, 0)

#define	SCL_HI		cbi(DDRA, 1)
#define	SCL_LO		sbi(DDRA, 1)
*/

#define	SDA_IS_LO	bit_is_clear(PINA, 6)
#define	SCL_IS_LO	bit_is_clear(PINA, 7)


static void SDA_HI(void)
{
	cbi(DDRA, 6);
}

static void SDA_LO(void)
{
	sbi(DDRA, 6);
}

static void SCL_HI(void)
{
	int	i;
	for(i = 0; i < 10; i++)	cbi(DDRA, 7);
}

static void SCL_LO(void)
{
	int	i;
	for(i = 0; i < 10; i++)	sbi(DDRA, 7);
}

void i2c_master_init(void)
{
	cbi(PORTA, 6);
	cbi(PORTA, 7);
	SDA_HI();
	SCL_HI();
}



void i2c_master_start_condition(void)
{
	SDA_HI();
	SCL_HI();

	SDA_LO();
	SCL_LO();
}

void i2c_master_stop_condition(void)
{
	SCL_LO();
	SDA_LO();

	SCL_HI();
	SDA_HI();
}

unsigned char i2c_master_write_byte(unsigned char data)
{
	int	i;
	unsigned char	ack;

//	xmitf(PSTR("W %02X "), data);

	for(i = 0; i < 8; i++)
	{
		if(data & 0x80)
			SDA_HI();
		else
			SDA_LO();

		SCL_HI();
		while(SCL_IS_LO)	{}		// SCL=LOW Ԓ҂
		SCL_LO();

		data <<= 1;
	}

	SDA_HI();
	SCL_HI();
	
//	xmitstr(SDA_IS_LO ? PSTR("ACK\r\n") : PSTR("NAK\r\n"));

	ack	= SDA_IS_LO;

	SCL_LO();

	return	ack;
}

unsigned char i2c_master_read_byte(unsigned char ack)
{
	int	i;
	unsigned char	data	= 0x00;

	SDA_HI();

	for(i = 0; i < 8; i++)
	{
		data <<= 1;

		SCL_HI();
		while(SCL_IS_LO)	{}		// SCL=LOW Ԓ҂

		if(!SDA_IS_LO)
			data |= 0x01;

		SCL_LO();
	}
	
	if(ack)
		SDA_LO();
	else
		SDA_HI();

	SCL_HI();

	SCL_LO();
	SDA_HI();

//	xmitf(PSTR("R %02X\r\n"), data);

	return	data;
}


